#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_width1 4
#property indicator_color2 Orchid
#property indicator_width2 4


extern string    note10 = "Periods First Moving Average";
extern int          MA1 = 10;
extern string    note11 = "MA Mode: 0=sma, 1=ema, 2=smma, 3=lwma";
extern int      MA1Mode = 1; 
extern string    note12 = "MA Price: 0=C, 1=O, 2=H, 3=L, 4=M (H+L/2)";
extern string    note13 = "5=T (H+L+C/3), 6=WC (H+L+2C/4)";
extern int     MA1Price = 0;
extern string    note14 = "Perioos Second Moving Average";
extern int          MA2 = 45;
extern int      MA2Mode = 1;
extern int     MA2Price = 0;
extern string    note15 = "Arrow Type";
extern string    note16 = "0=Thick, 1=Thin, 2=Hollow, 3=Round";
extern string    note17 = "4=Fractal, 5=Diagonal Thin";
extern string    note18 = "6=Diagonal Thick, 7=Diagonal Hollow";
extern string    note19 = "8=Thumb, 9=Finger";
extern int    ArrowType = 0;
extern string    note20 = "Alert on?";
extern bool     AlertOn = true;
extern string    note21 = "Email Alert on?";
extern bool SendAnEmail = true;



double CrossUp[];
double CrossDown[];


string AlertPrefix, MA1short_name, MA2short_name;

string GetTimeFrameStr()

 {
   switch(Period())
   
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr=Period();
   } 
   return (TimeFrameStr);
   
 }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


int init()

  {
   
   SetIndexStyle(0,DRAW_ARROW, EMPTY, 4);
   SetIndexStyle(1,DRAW_ARROW, EMPTY, 4);
   if (ArrowType == 0) {
      SetIndexArrow(0, 233);
      SetIndexArrow(1, 234);
   }
   else if (ArrowType == 1) {
      SetIndexArrow(0, 225);
      SetIndexArrow(1, 226);
   }
   else if (ArrowType == 2) {
      SetIndexArrow(0, 241);
      SetIndexArrow(1, 242);
   }
   else if (ArrowType == 3) {
      SetIndexArrow(0, 221);
      SetIndexArrow(1, 222);
   }
   else if (ArrowType == 4) {
      SetIndexArrow(0, 217);
      SetIndexArrow(1, 218);
   }
   else if (ArrowType == 5) {
      SetIndexArrow(0, 228);
      SetIndexArrow(1, 230);
   }
   else if (ArrowType == 6) {
      SetIndexArrow(0, 236);
      SetIndexArrow(1, 238);
   }
   else if (ArrowType == 7) {
      SetIndexArrow(0, 246);
      SetIndexArrow(1, 248);
   }
   else if (ArrowType == 8) {
      SetIndexArrow(0, 67);
      SetIndexArrow(1, 68);
   }
   else if (ArrowType == 9) {
      SetIndexArrow(0, 71);
      SetIndexArrow(1, 72);
   }

   SetIndexBuffer(0, CrossUp);
   SetIndexBuffer(1, CrossDown);

//---- indicator short name
   switch(MA1Mode)
     {
      case 1 : MA1short_name="EMA";  break;
      case 2 : MA1short_name="SMMA"; break;
      case 3 : MA1short_name="LWMA"; break;
      default :
         MA1Mode=0;
         MA1short_name="SMA";
     }
   switch(MA2Mode)
     {
      case 1 : MA2short_name="EMA";  break;
      case 2 : MA2short_name="SMMA"; break;
      case 3 : MA2short_name="LWMA"; break;
      default :
         MA2Mode=0;
         MA2short_name="SMA";
     }

   AlertPrefix=Symbol()+" ("+GetTimeFrameStr()+"):  ";
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
bool NewBar()
{  static datetime lastbar;
   datetime curbar = Time[0];
   if(lastbar == 0)
      {  lastbar=curbar;
         return(false);
      }
   else if(lastbar!=curbar)
      {   lastbar=curbar;
          return (true);
      }
   else return(false);
}   
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double MA1now, MA2now, MA1previous, MA2previous, MA1after, MA2after;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      MA1now = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i);
      MA1previous = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i+1);
      MA1after = iMA(NULL, 0, MA1, 0, MA1Mode, MA1Price, i-1);

      MA2now = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i);
      MA2previous = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i+1);
      MA2after = iMA(NULL, 0, MA2, 0, MA2Mode, MA2Price, i-1);
      
      if ((MA1now > MA2now) && (MA1previous < MA2previous) && (MA1after > MA2after)) CrossUp[i] = Low[i] - Range*1.5;
      else if ((MA1now < MA2now) && (MA1previous > MA2previous) && (MA1after < MA2after)) CrossDown[i] = High[i] + Range*1.5;
   }
   if(NewBar())
      {  if(CrossUp[1]!=EMPTY_VALUE)
            {     if (AlertOn) Alert(AlertPrefix+MA1short_name+" ("+MA1+") "+"crosses UP " + MA2short_name+" ("+MA2+")");
                  if (SendAnEmail) SendMail(StringConcatenate(Symbol()," Price closed above MA")," Price closed above moving average");
            }
         if(CrossDown[1]!=EMPTY_VALUE)
            {     if (AlertOn) Alert(AlertPrefix+MA1short_name+" ("+MA1+") "+"crosses DOWN " + MA2short_name+" ("+MA2+")");
                  if (SendAnEmail) SendMail(StringConcatenate(Symbol()," Price closed below MA"),"Price closed below moving average");
            }
      }
   return(0);
}

